      subroutine nokinem(e1,e2,x1,x2,oplc,opld,genkin)
c----------------------------------------------------------------------c
c Eliminates writing of the kinematics of a 2 particles scattering 
c process should for certain topologies
c 
c Karol Kolodziej, University of Silesia, karol.kolodziej@us.edu.pl
c 11 June, 2014; modified on 17 June, 2014 
c----------------------------------------------------------------------c

      integer :: e1,e2,x1(e1,3),x2(e2,3),i,inprt,iqrt
      logical :: genkin
      character(80) :: oplc,opld

      if (index(oplc,'mixing') > 0 .or. index(opld,'mixing') > 0) then
       genkin=.false.          ! 17 June, 2014 
       return
      end if

      inprt=0
      iqrt=0
      if (e1 == 1) then
       do i=1,3
        if (x1(e1,i) > 0 .and. x1(e1,i) <= 2) inprt=inprt+1
       end do
       if (inprt == 2) then
        if (x2(e2,3) /= 0) then
         iqrt=1
         do i=1,e2-1
          if (x2(i,3) /= 0) iqrt=iqrt+1
         end do
        end if
       end if
      else if (e2 == 1) then
       do i=1,3
        if (x2(e2,i) > 0 .and. x2(e2,i) <= 2) inprt=inprt+1
       end do
       if (inprt == 2) then
        if (x1(e1,3) /= 0) then
         iqrt=1
         do i=1,e1-1
          if (x1(i,3) /= 0) iqrt=iqrt+1
         end do
        end if
       end if
      end if

      if (iqrt > 1) genkin=.false.

      end
