      subroutine kinkk1(ikin,imom,ecm,m,p,x,ndim,dlips)
 
      use inprms
      use kincuts
      use ntnkin
 
      implicit none
 
      integer, parameter :: nepl=6
      integer :: ikin,imom,ndim
      real(dp) :: ecm,m(nepl),p(0:3,nepl),x(ndim),dlips,v(3),g
      real(dp), dimension(0:3) :: q1,q2
      real(dp) :: sqsl1,sqsl2
      real(dp) :: sqsu1,sqsu2
      real(dp) :: sqs1,sqs2
      real(dp) :: ds1,ds2
      real(dp) :: s1,s2
      real(dp) :: dl1,dl2
 
      if (ikin <= nt1) then
       sqsl1=m(3)+m(4)
       sqsl2=sqsl1+m(5)
       if (imom /= 1) then
        q1=p(:,3)+p(:,4)
        q2=q1+p(:,5)
       end if
       if (ikin == 1) then
       sqsu2=ecm-m(6)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 2) then
       sqsu2=ecm-m(6)
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 3) then
       sqsu2=ecm-m(6)
       call mapbkk(imom,x(2),q2,mome,gmom,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 4) then
       sqsu2=ecm-m(6)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 5) then
       sqsu2=ecm-m(6)
       call mapbkk(imom,x(2),q2,mome,gmom,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 6) then
       sqsu2=ecm-m(6)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       call mapbkk(imom,x(1),q1,mome,gmom,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 7) then
       sqsu2=ecm-m(6)
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       call mapbkk(imom,x(1),q1,mome,gmom,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(4),x(3:4),p(:,3),p(:,4),dl1)
       call kinff(imom,sqs2,sqs1,m(5),x(5:6),q1,p(:,5),dl2)
       call kinff(imom,ecm,m(6),sqs2,x(7:8),p(:,6),q2,dlips)
       dlips=dlips*ds1*ds2
     &            *dl1*dl2
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt3) then
       sqsl1=m(3)+m(4)
       sqsl2=sqsl1+m(5)
       if (imom /= 1) then
        q1=p(:,3)+p(:,4)
        q2=q1+p(:,5)
       end if
       if (ikin == 8) then
       sqsu2=ecm-m(6)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       ds1=(sqsu1-sqsl1)*(sqsu1+sqsl1)
       if (imom == 1) then
        s1=ds1*x(1)+sqsl1*sqsl1
       else
        s1=(q1(0)-q1(3))*(q1(0)+q1(3))-q1(1)*q1(1)-q1(2)*q1(2)
       end if
       sqs1=sqrt(s1)
       end if
       if (ikin == 9) then
       sqsu2=ecm-m(6)
       call mapbkk(imom,x(2),q2,mome,gmom,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       ds1=(sqsu1-sqsl1)*(sqsu1+sqsl1)
       if (imom == 1) then
        s1=ds1*x(1)+sqsl1*sqsl1
       else
        s1=(q1(0)-q1(3))*(q1(0)+q1(3))-q1(1)*q1(1)-q1(2)*q1(2)
       end if
       sqs1=sqrt(s1)
       end if
       call kinff(imom,sqs1,m(3),m(4),x(3:4),p(:,3),p(:,4),dl1)
       call kinff(imom,sqs2,sqs1,m(5),x(5:6),q1,p(:,5),dl2)
       call kinff(imom,ecm,m(6),sqs2,x(7:8),p(:,6),q2,dlips)
       dlips=dlips*ds1*ds2
     &            *dl1*dl2
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      end if
 
      end
